diff --git a/src/backend/executor/nodeModifyTable.c b/src/backend/executor/nodeModifyTable.c
index 562c419..bede096 100644
--- a/src/backend/executor/nodeModifyTable.c
+++ b/src/backend/executor/nodeModifyTable.c
@@ -582,6 +582,103 @@ lreplace:;
 	return NULL;
 }
 
+static TupleTableSlot *
+ExecMerge(ItemPointer tupleid,
+		   TupleTableSlot *slot,
+		   TupleTableSlot *planSlot,
+		   MergeActionSet *actset,
+		   EState *estate)
+{
+
+	TupleTableSlot *actslot = NULL;
+	ListCell *each;
+
+	/*
+	 * Try the merge actions one by one until we have a match.
+	 */
+	foreach(each, actset->actions)
+	{
+		ModifyTableState *mt_pstate;
+		MergeActionState *action_pstate;
+		ExprContext *econtext;
+		bool matched;
+
+		mt_pstate = (ModifyTableState *) lfirst(each);
+		Assert(IsA(mt_pstate, ModifyTableState));
+
+		/*
+		 * mt_pstate is supposed to have only ONE mt_plans,
+		 * which is a MergeActionState
+		 */
+		action_pstate = (MergeActionState *) mt_pstate->mt_plans[0];
+		matched = ((MergeAction *)action_pstate->ps.plan)->matched;
+
+		/*
+		 * If tupleid == NULL, it is a NOT MATCHED case,
+		 * else, it is a MATCHED case,
+		 */
+		if ((tupleid == NULL && matched) || 
+			(tupleid != NULL && !matched))
+			continue;
+
+		/* Setup the expression context. */
+		econtext = action_pstate->ps.ps_ExprContext;
+
+		/*
+		 * Check that additional quals match, if any.
+		 */
+		if (action_pstate->ps.qual)
+		{
+			ResetExprContext(econtext);
+
+			econtext->ecxt_scantuple = slot;
+			econtext->ecxt_outertuple = planSlot;
+
+			if (!ExecQual(action_pstate->ps.qual, econtext, false))
+				continue;
+		}
+
+		/* Ok, we have a match. Perform the action */
+
+		/* First project any RETURNING result tuple slot, if needed */
+		if (action_pstate->operation == CMD_INSERT ||
+			action_pstate->operation == CMD_UPDATE)
+			actslot = ExecProcessReturning(action_pstate->ps.ps_ProjInfo,
+										   slot, planSlot);
+
+		switch (action_pstate->operation)
+		{
+			case CMD_INSERT:
+				return ExecInsert(actslot, planSlot, estate);
+
+			case CMD_UPDATE:
+				return ExecUpdate(tupleid,
+								  actslot,
+								  planSlot,
+								  &mt_pstate->mt_epqstate,
+								  estate);
+
+			case CMD_DELETE:
+				return ExecDelete(tupleid,
+								  planSlot,
+								  &mt_pstate->mt_epqstate,
+								  estate);
+
+			case CMD_DONOTHING:
+				return NULL;
+
+			default:
+				elog(ERROR, "unknown merge action type for execute");
+				break;
+		}
+	}
+
+	/*
+	 * No matching action found. Perform the default action, which is
+	 * DO NOTHING.
+	 */
+	return NULL;
+}
 
 /*
  * Process BEFORE EACH STATEMENT triggers
@@ -603,6 +700,9 @@ fireBSTriggers(ModifyTableState *node)
 			ExecBSDeleteTriggers(node->ps.state,
 								 node->ps.state->es_result_relations);
 			break;
+		case CMD_MERGE:
+			ExecBSMergeTriggers(node);
+			break;
 		default:
 			elog(ERROR, "unknown operation");
 			break;
@@ -629,6 +729,9 @@ fireASTriggers(ModifyTableState *node)
 			ExecASDeleteTriggers(node->ps.state,
 								 node->ps.state->es_result_relations);
 			break;
+		case CMD_MERGE:
+			ExecASMergeTriggers(node);
+			break;
 		default:
 			elog(ERROR, "unknown operation");
 			break;
@@ -654,6 +757,7 @@ ExecModifyTable(ModifyTableState *node)
 	TupleTableSlot *planSlot;
 	ItemPointer tupleid = NULL;
 	ItemPointerData tuple_ctid;
+	MergeActionSet *mergeActSet = NULL;
 
 	/*
 	 * On first call, fire BEFORE STATEMENT triggers before proceeding.
@@ -675,6 +779,8 @@ ExecModifyTable(ModifyTableState *node)
 	/* Preload local variables */
 	subplanstate = node->mt_plans[node->mt_whichplan];
 	junkfilter = estate->es_result_relation_info->ri_junkFilter;
+	if(node->mt_mergeActPstates)
+		mergeActSet = node->mt_mergeActPstates[node->mt_whichplan];
 
 	/*
 	 * Fetch rows from subplan(s), and execute the required table modification
@@ -701,6 +807,8 @@ ExecModifyTable(ModifyTableState *node)
 				estate->es_result_relation_info++;
 				subplanstate = node->mt_plans[node->mt_whichplan];
 				junkfilter = estate->es_result_relation_info->ri_junkFilter;
+				if(node->mt_mergeActPstates)
+					mergeActSet = node->mt_mergeActPstates[node->mt_whichplan];
 				EvalPlanQualSetPlan(&node->mt_epqstate, subplanstate->plan);
 				continue;
 			}
@@ -716,20 +824,32 @@ ExecModifyTable(ModifyTableState *node)
 			/*
 			 * extract the 'ctid' junk attribute.
 			 */
-			if (operation == CMD_UPDATE || operation == CMD_DELETE)
+			if (operation == CMD_UPDATE || operation == CMD_DELETE || operation == CMD_MERGE)
 			{
 				Datum		datum;
 				bool		isNull;
 
 				datum = ExecGetJunkAttribute(slot, junkfilter->jf_junkAttNo,
 											 &isNull);
-				/* shouldn't ever get a null result... */
+
 				if (isNull)
-					elog(ERROR, "ctid is NULL");
+				{
+					/*
+					 * Shouldn't ever get a null result for UPDATE or DELETE.
+					 * MERGE gets a null ctid in "NOT MATCHED" case
+					 */
+					if (operation != CMD_MERGE)
+						elog(ERROR, "ctid is NULL");
+					else
+						tupleid = NULL;
+				}
+				else
+				{
 
-				tupleid = (ItemPointer) DatumGetPointer(datum);
-				tuple_ctid = *tupleid;	/* be sure we don't free the ctid!! */
-				tupleid = &tuple_ctid;
+					tupleid = (ItemPointer) DatumGetPointer(datum);
+					tuple_ctid = *tupleid;	/* be sure we don't free the ctid!! */
+					tupleid = &tuple_ctid;
+				}
 			}
 
 			/*
@@ -752,6 +872,10 @@ ExecModifyTable(ModifyTableState *node)
 				slot = ExecDelete(tupleid, planSlot,
 								  &node->mt_epqstate, estate);
 				break;
+			case CMD_MERGE:
+				slot = ExecMerge(tupleid, slot, planSlot,
+								 mergeActSet, estate);
+				break;
 			default:
 				elog(ERROR, "unknown operation");
 				break;
@@ -779,6 +903,69 @@ ExecModifyTable(ModifyTableState *node)
 	return NULL;
 }
 
+/*
+ *	When init a merge plan, we also need init its action plans.
+ *	These action plans are "MergeAction" plans.
+ *
+ *	This function mainly handles the tlist and qual in the plan.
+ *	The returning result is a "MergeActionState".
+ */
+MergeActionState *
+ExecInitMergeAction(MergeAction *node, EState *estate, int eflags)
+{
+	MergeActionState *result;
+
+	/*
+	 * do nothing when we get to the end of a leaf on tree.
+	 */
+	if (node == NULL)
+		return NULL;
+
+	/*
+	 * create state structure
+	 */
+	result = makeNode(MergeActionState);
+	result->operation = node->operation;
+	result->ps.plan = (Plan *)node;
+	result->ps.state = estate;
+
+	/*
+	 * tuple table initialization
+	 */
+	ExecInitResultTupleSlot(estate, &result->ps);
+
+	/*
+	 * initialize tuple type
+	 */
+	ExecAssignResultTypeFromTL(&result->ps);
+
+	/*
+	 * create expression context for node
+	 */
+	ExecAssignExprContext(estate, &result->ps);
+
+	/*
+	 * initialize child expressions
+	 */
+	result->ps.targetlist = (List *)
+		ExecInitExpr((Expr *) node->plan.targetlist,  &result->ps);
+
+	result->ps.qual = (List *)
+		ExecInitExpr((Expr *) node->plan.qual, &result->ps);
+
+	/*
+	 * init the projection information
+	 */
+	ExecAssignProjectionInfo(&result->ps, NULL);
+
+	/*
+	 * XXX: do we need a check for the plan output here ?
+	 * (by calling the ExecCheckPlanOutput() function
+	 */
+
+	return result;
+}
+
 /* ----------------------------------------------------------------
  *		ExecInitModifyTable
  * ----------------------------------------------------------------
@@ -794,6 +981,7 @@ ExecInitModifyTable(ModifyTable *node, EState *estate, int eflags)
 	Plan	   *subplan;
 	ListCell   *l;
 	int			i;
+	bool 		isMergeAction = false;
 
 	/* check for unsupported flags */
 	Assert(!(eflags & (EXEC_FLAG_BACKWARD | EXEC_FLAG_MARK)));
@@ -834,6 +1022,16 @@ ExecInitModifyTable(ModifyTable *node, EState *estate, int eflags)
 	foreach(l, node->plans)
 	{
 		subplan = (Plan *) lfirst(l);
+
+		/*
+		 * 	test if this subplan node is a MergeAction.
+		 * 	We need this information for setting the junkfilter.
+		 *	junkfilter is necessary for an ordinary UPDATE/DELETE plan,
+		 *	but not for an UPDATE/DELETE merge action
+		 */
+		if (IsA(subplan, MergeAction))
+			isMergeAction = true;
+
 		mtstate->mt_plans[i] = ExecInitNode(subplan, estate, eflags);
 		estate->es_result_relation_info++;
 		i++;
@@ -963,7 +1161,11 @@ ExecInitModifyTable(ModifyTable *node, EState *estate, int eflags)
 				break;
 			case CMD_UPDATE:
 			case CMD_DELETE:
-				junk_filter_needed = true;
+			case CMD_MERGE:
+				if(!isMergeAction)
+					junk_filter_needed = true;
+				break;
+			case CMD_DONOTHING:
 				break;
 			default:
 				elog(ERROR, "unknown operation");
@@ -986,9 +1188,10 @@ ExecInitModifyTable(ModifyTable *node, EState *estate, int eflags)
 							resultRelInfo->ri_RelationDesc->rd_att->tdhasoid,
 									   ExecInitExtraTupleSlot(estate));
 
-				if (operation == CMD_UPDATE || operation == CMD_DELETE)
+				if (operation == CMD_UPDATE || operation == CMD_DELETE ||
+					operation == CMD_MERGE)
 				{
-					/* For UPDATE/DELETE, find the ctid junk attr now */
+					/* For UPDATE/DELETE/MERGE, find the ctid junk attr now */
 					j->jf_junkAttNo = ExecFindJunkAttribute(j, "ctid");
 					if (!AttributeNumberIsValid(j->jf_junkAttNo))
 						elog(ERROR, "could not find junk ctid column");
@@ -1014,6 +1217,36 @@ ExecInitModifyTable(ModifyTable *node, EState *estate, int eflags)
 	if (estate->es_trig_tuple_slot == NULL)
 		estate->es_trig_tuple_slot = ExecInitExtraTupleSlot(estate);
 
+	/*
+	 * for the merge actions, we need to do similar things as above.
+	 *Each action in each action set should be init by the ExecInitNode.
+	 *The returned planstates will take the place of the original plan nodes.
+	 *These new action set will be put in the mt_mergeActPstates array.
+	 */
+	if(node->operation == CMD_MERGE)
+	{
+		/*we have one action set for each result relation (main plan)*/
+		mtstate->mt_mergeActPstates = 
+			(MergeActionSet **) palloc0(sizeof(MergeActionSet*) * nplans);
+
+		estate->es_result_relation_info = estate->es_result_relations;
+		i = 0;
+		foreach(l, node->mergeActPlan)
+		{
+			ListCell *e;
+			MergeActionSet *actset = (MergeActionSet *) lfirst(l);
+
+			foreach(e, actset->actions)
+			{
+				lfirst(e) = ExecInitNode((Plan *)lfirst(e),  estate, 0);
+			}		
+			mtstate->mt_mergeActPstates[i] = actset;
+			estate->es_result_relation_info++;
+			i++;
+		}
+		estate->es_result_relation_info = NULL;
+	}
+
 	return mtstate;
 }
 
diff --git a/src/backend/nodes/copyfuncs.c b/src/backend/nodes/copyfuncs.c
index 87de0c5..3ff2dce 100644
--- a/src/backend/nodes/copyfuncs.c
+++ b/src/backend/nodes/copyfuncs.c
@@ -177,6 +177,42 @@ _copyModifyTable(ModifyTable *from)
 	COPY_NODE_FIELD(returningLists);
 	COPY_NODE_FIELD(rowMarks);
 	COPY_SCALAR_FIELD(epqParam);
+	COPY_NODE_FIELD(mergeActPlan);
+
+	return newnode;
+}
+
+/*
+ * _copyMergeAction
+ */
+static MergeAction *
+_copyMergeAction(MergeAction *from)
+{
+	MergeAction *newnode = makeNode(MergeAction);
+
+	/*
+	 * copy node superclass fields
+	 */
+	CopyPlanFields((Plan *) from, (Plan *) newnode);
+
+	COPY_SCALAR_FIELD(operation);	
+	COPY_SCALAR_FIELD(matched);
+	COPY_NODE_FIELD(flattenedqual);
+	COPY_NODE_FIELD(flattenedtlist);
+
+	return newnode;
+}
+
+/*
+ * _copyMergeActionSet
+ */
+static MergeActionSet *
+_copyMergeActionSet(MergeActionSet *from)
+{
+	MergeActionSet *newnode = makeNode(MergeActionSet);
+
+	COPY_SCALAR_FIELD(result_relation);
+	COPY_NODE_FIELD(actions);
 
 	return newnode;
 }
@@ -2274,6 +2310,10 @@ _copyQuery(Query *from)
 	COPY_NODE_FIELD(rowMarks);
 	COPY_NODE_FIELD(setOperations);
 	COPY_NODE_FIELD(constraintDeps);
+	COPY_SCALAR_FIELD(isMergeAction);
+	COPY_SCALAR_FIELD(matched);
+	COPY_SCALAR_FIELD(sourceAttrNo);
+	COPY_NODE_FIELD(mergeActQry);
 
 	return newnode;
 }
@@ -2283,6 +2323,7 @@ _copyInsertStmt(InsertStmt *from)
 {
 	InsertStmt *newnode = makeNode(InsertStmt);
 
+	COPY_SCALAR_FIELD(isMergeAction);
 	COPY_NODE_FIELD(relation);
 	COPY_NODE_FIELD(cols);
 	COPY_NODE_FIELD(selectStmt);
@@ -2296,6 +2337,7 @@ _copyDeleteStmt(DeleteStmt *from)
 {
 	DeleteStmt *newnode = makeNode(DeleteStmt);
 
+	COPY_SCALAR_FIELD(isMergeAction);
 	COPY_NODE_FIELD(relation);
 	COPY_NODE_FIELD(usingClause);
 	COPY_NODE_FIELD(whereClause);
@@ -2309,6 +2351,7 @@ _copyUpdateStmt(UpdateStmt *from)
 {
 	UpdateStmt *newnode = makeNode(UpdateStmt);
 
+	COPY_SCALAR_FIELD(isMergeAction);
 	COPY_NODE_FIELD(relation);
 	COPY_NODE_FIELD(targetList);
 	COPY_NODE_FIELD(whereClause);
@@ -2345,6 +2388,47 @@ _copySelectStmt(SelectStmt *from)
 	return newnode;
 }
 
+static MergeStmt *
+_copyMergeStmt(MergeStmt *from)
+{
+	MergeStmt *newnode = makeNode(MergeStmt);
+
+	COPY_NODE_FIELD(relation);
+	COPY_NODE_FIELD(source);
+	COPY_NODE_FIELD(matchCondition);
+	COPY_NODE_FIELD(actions);
+
+	return newnode;
+}
+
+static MergeConditionAction *
+_copyMergeConditionAction(MergeConditionAction *from)
+{
+	MergeConditionAction *newnode = makeNode(MergeConditionAction);
+
+	COPY_SCALAR_FIELD(match);
+	COPY_NODE_FIELD(condition);
+	COPY_NODE_FIELD(action);
+
+	return newnode;
+}
+
+static MergeDoNothing *
+_copyMergeDoNothing(MergeDoNothing *from)
+{
+	MergeDoNothing *newnode = makeNode(MergeDoNothing);
+
+	return newnode;
+}
+
+static MergeError*
+_copyMergeError(MergeError *from)
+{
+	MergeError *newnode = makeNode(MergeError);
+
+	return newnode;
+}
+
 static SetOperationStmt *
 _copySetOperationStmt(SetOperationStmt *from)
 {
@@ -3607,6 +3691,12 @@ copyObject(void *from)
 		case T_ModifyTable:
 			retval = _copyModifyTable(from);
 			break;
+		case T_MergeAction:
+			retval = _copyMergeAction(from);
+			break;
+		case T_MergeActionSet:
+			retval = _copyMergeActionSet(from);
+			break;
 		case T_Append:
 			retval = _copyAppend(from);
 			break;
@@ -3907,6 +3997,18 @@ copyObject(void *from)
 		case T_SelectStmt:
 			retval = _copySelectStmt(from);
 			break;
+		case T_MergeStmt:
+			retval = _copyMergeStmt(from);
+			break;
+		case T_MergeConditionAction:
+			retval = _copyMergeConditionAction(from);
+			break;
+		case T_MergeDoNothing:
+			retval = _copyMergeDoNothing(from);
+			break;
+		case T_MergeError:
+			retval = _copyMergeError(from);
+			break;
 		case T_SetOperationStmt:
 			retval = _copySetOperationStmt(from);
 			break;
diff --git a/src/backend/nodes/equalfuncs.c b/src/backend/nodes/equalfuncs.c
index 6f6e9e4..4d0d7c3 100644
--- a/src/backend/nodes/equalfuncs.c
+++ b/src/backend/nodes/equalfuncs.c
@@ -878,6 +878,10 @@ _equalQuery(Query *a, Query *b)
 	COMPARE_NODE_FIELD(rowMarks);
 	COMPARE_NODE_FIELD(setOperations);
 	COMPARE_NODE_FIELD(constraintDeps);
+	COMPARE_SCALAR_FIELD(isMergeAction);
+	COMPARE_SCALAR_FIELD(matched);
+	COMPARE_SCALAR_FIELD(sourceAttrNo);
+	COMPARE_NODE_FIELD(mergeActQry);
 
 	return true;
 }
@@ -885,6 +889,7 @@ _equalQuery(Query *a, Query *b)
 static bool
 _equalInsertStmt(InsertStmt *a, InsertStmt *b)
 {
+	COMPARE_SCALAR_FIELD(isMergeAction);
 	COMPARE_NODE_FIELD(relation);
 	COMPARE_NODE_FIELD(cols);
 	COMPARE_NODE_FIELD(selectStmt);
@@ -896,6 +901,7 @@ _equalInsertStmt(InsertStmt *a, InsertStmt *b)
 static bool
 _equalDeleteStmt(DeleteStmt *a, DeleteStmt *b)
 {
+	COMPARE_SCALAR_FIELD(isMergeAction);
 	COMPARE_NODE_FIELD(relation);
 	COMPARE_NODE_FIELD(usingClause);
 	COMPARE_NODE_FIELD(whereClause);
@@ -907,6 +913,7 @@ _equalDeleteStmt(DeleteStmt *a, DeleteStmt *b)
 static bool
 _equalUpdateStmt(UpdateStmt *a, UpdateStmt *b)
 {
+	COMPARE_SCALAR_FIELD(isMergeAction);
 	COMPARE_NODE_FIELD(relation);
 	COMPARE_NODE_FIELD(targetList);
 	COMPARE_NODE_FIELD(whereClause);
diff --git a/src/backend/nodes/outfuncs.c b/src/backend/nodes/outfuncs.c
index d0ba12c..65b5347 100644
--- a/src/backend/nodes/outfuncs.c
+++ b/src/backend/nodes/outfuncs.c
@@ -332,6 +332,7 @@ _outModifyTable(StringInfo str, ModifyTable *node)
 	WRITE_NODE_FIELD(returningLists);
 	WRITE_NODE_FIELD(rowMarks);
 	WRITE_INT_FIELD(epqParam);
+	WRITE_NODE_FIELD(mergeActPlan);
 }
 
 static void
@@ -2022,6 +2023,53 @@ _outQuery(StringInfo str, Query *node)
 	WRITE_NODE_FIELD(rowMarks);
 	WRITE_NODE_FIELD(setOperations);
 	WRITE_NODE_FIELD(constraintDeps);
+	WRITE_BOOL_FIELD(isMergeAction);
+	WRITE_BOOL_FIELD(matched);
+	WRITE_INT_FIELD(sourceAttrNo);
+	WRITE_NODE_FIELD(mergeActQry);
+}
+
+static void
+_outMergeConditionAction(StringInfo str, MergeConditionAction *node)
+{
+	WRITE_NODE_TYPE("MERGECONDITIONACTION");
+
+	WRITE_BOOL_FIELD(match);
+	WRITE_NODE_FIELD(condition);
+	WRITE_NODE_FIELD(action);
+}
+
+static void
+_outMergeStmt(StringInfo str, MergeStmt *node)
+{
+	WRITE_NODE_TYPE("MERGESTMT");
+
+	WRITE_NODE_FIELD(relation);
+	WRITE_NODE_FIELD(source);
+	WRITE_NODE_FIELD(matchCondition);
+	WRITE_NODE_FIELD(actions);
+}
+
+static void
+_outMergeAction(StringInfo str, MergeAction *node)
+{
+	WRITE_NODE_TYPE("MERGEACTION");
+
+	_outPlanInfo(str, (Plan *)node);
+
+	WRITE_ENUM_FIELD(operation, CmdType);
+	WRITE_BOOL_FIELD(matched);
+	WRITE_NODE_FIELD(flattenedqual);
+	WRITE_NODE_FIELD(flattenedtlist);
+}
+
+static void
+_outMergeActionSet(StringInfo str, MergeActionSet *node)
+{
+	WRITE_NODE_TYPE("MERGEACTIONSET");
+
+	WRITE_INT_FIELD(result_relation);
+	WRITE_NODE_FIELD(actions);
 }
 
 static void
@@ -2907,6 +2955,18 @@ _outNode(StringInfo str, void *obj)
 			case T_XmlSerialize:
 				_outXmlSerialize(str, obj);
 				break;
+			case T_MergeAction:
+				_outMergeAction(str, obj);
+				break;
+			case T_MergeActionSet:
+				_outMergeActionSet(str, obj);
+				break;
+			case T_MergeStmt:
+				_outMergeStmt(str, obj);
+				break;
+			case T_MergeConditionAction:
+				_outMergeConditionAction(str,obj);
+				break;			
 
 			default:
 
diff --git a/src/backend/nodes/readfuncs.c b/src/backend/nodes/readfuncs.c
index 0a2edcb..0aeab17 100644
--- a/src/backend/nodes/readfuncs.c
+++ b/src/backend/nodes/readfuncs.c
@@ -219,6 +219,10 @@ _readQuery(void)
 	READ_NODE_FIELD(rowMarks);
 	READ_NODE_FIELD(setOperations);
 	READ_NODE_FIELD(constraintDeps);
+	READ_BOOL_FIELD(isMergeAction);
+	READ_BOOL_FIELD(matched);
+	READ_INT_FIELD(sourceAttrNo);
+	READ_NODE_FIELD(mergeActQry);
 
 	READ_DONE();
 }
diff --git a/src/backend/optimizer/plan/createplan.c b/src/backend/optimizer/plan/createplan.c
index 2115cc0..f5df243 100644
--- a/src/backend/optimizer/plan/createplan.c
+++ b/src/backend/optimizer/plan/createplan.c
@@ -3919,7 +3919,7 @@ make_result(PlannerInfo *root,
 ModifyTable *
 make_modifytable(CmdType operation, List *resultRelations,
 				 List *subplans, List *returningLists,
-				 List *rowMarks, int epqParam)
+				 List *rowMarks, List *mergeActPlans, int epqParam)
 {
 	ModifyTable *node = makeNode(ModifyTable);
 	Plan	   *plan = &node->plan;
@@ -3972,6 +3972,8 @@ make_modifytable(CmdType operation, List *resultRelations,
 	node->returningLists = returningLists;
 	node->rowMarks = rowMarks;
 	node->epqParam = epqParam;
+	if (operation == CMD_MERGE)
+		node->mergeActPlan = mergeActPlans;
 
 	return node;
 }
diff --git a/src/backend/optimizer/plan/planner.c b/src/backend/optimizer/plan/planner.c
index 3950ab4..c627e6e 100644
--- a/src/backend/optimizer/plan/planner.c
+++ b/src/backend/optimizer/plan/planner.c
@@ -102,7 +102,8 @@ static void get_column_info_for_window(PlannerInfo *root, WindowClause *wc,
 						   int *ordNumCols,
 						   AttrNumber **ordColIdx,
 						   Oid **ordOperators);
-
+static ModifyTable *merge_action_planner(PlannerInfo *root, Plan *mainPlan);
+static MergeActionSet *merge_action_set_planner(PlannerInfo *root, Plan *mainPlan);
 
 /*****************************************************************************
  *
@@ -452,6 +453,27 @@ subquery_planner(PlannerGlobal *glob, Query *parse,
 	}
 
 	/*
+	* for MERGE command, we need to preprocess 
+	* the expressions for merge actions too.
+	*/
+	if(parse->commandType == CMD_MERGE)
+	{
+		ListCell *e;
+
+		foreach(e, parse->mergeActQry)
+		{
+			Query *actqry = (Query *)lfirst(e);
+			
+			actqry->targetList = (List *) preprocess_expression(root, 
+										(Node *) actqry->targetList,
+										EXPRKIND_TARGET);
+			actqry->jointree->quals = preprocess_expression(root, 
+										(Node *) actqry->jointree->quals,
+										EXPRKIND_QUAL);
+		}
+	}
+
+	/*
 	 * In some cases we may want to transfer a HAVING clause into WHERE. We
 	 * cannot do so if the HAVING clause contains aggregates (obviously) or
 	 * volatile functions (since a HAVING clause is supposed to be executed
@@ -528,6 +550,7 @@ subquery_planner(PlannerGlobal *glob, Query *parse,
 		{
 			List	   *returningLists;
 			List	   *rowMarks;
+			List 		*mergeAction;
 
 			/*
 			 * Deal with the RETURNING clause if any.  It's convenient to pass
@@ -559,12 +582,19 @@ subquery_planner(PlannerGlobal *glob, Query *parse,
 			else
 				rowMarks = root->rowMarks;
 
+			/*if here is a MERGE command, we need to plan the actions too*/
+			if(parse->commandType == CMD_MERGE)
+				mergeAction = list_make1(merge_action_set_planner(root, plan));
+			else
+				mergeAction = NIL;
+			
 			plan = (Plan *) make_modifytable(parse->commandType,
 										   copyObject(root->resultRelations),
 											 list_make1(plan),
 											 returningLists,
 											 rowMarks,
-											 SS_assign_special_param(root));
+											 mergeAction,
+											 SS_assign_special_param(root));			
 		}
 	}
 
@@ -585,6 +615,130 @@ subquery_planner(PlannerGlobal *glob, Query *parse,
 }
 
 /*
+to generate the merge action set for the main plan. 
+Call this function after the grouping_planner()
+
+Only works for MERGE command
+*/
+static MergeActionSet *
+merge_action_set_planner(PlannerInfo *root, Plan *mainPlan)
+{
+	MergeActionSet *result;
+	Query *mainQry = root->parse;
+	ListCell *l;
+	PlannerInfo subroot;
+
+	/*for non-merge command, no need to plan the merge actions*/
+	if(mainQry->commandType != CMD_MERGE ||
+		mainQry->mergeActQry == NIL)
+		return NULL;
+
+	/*do a copy of the root info*/
+	memcpy(&subroot, root, sizeof(PlannerInfo));
+
+	/*create the result node*/
+	result = makeNode(MergeActionSet);
+	result->result_relation = mainQry->resultRelation;
+	result->actions = NIL;
+
+	/*plan the actions one by one*/	
+	foreach(l, mainQry->mergeActQry)
+	{
+		ModifyTable *actplan;
+
+		/*put the action query into the subroot*/
+		subroot.parse = (Query *) lfirst(l);
+		actplan = merge_action_planner(&subroot, mainPlan);
+		result->actions = lappend(result->actions, actplan);
+	}
+	return result;
+}
+
+/* create plan for a single merge action */
+static ModifyTable *
+merge_action_planner(PlannerInfo *root, Plan *mainPlan)
+{
+	Query *parse = root->parse;
+	MergeAction	*actplan;
+	ModifyTable *result;
+
+	List	   	*returningLists;
+	List 		*rowMarks;
+
+	/*
+	 * no having clause in a merge action
+	 */
+	Assert(parse->havingQual == NULL);
+
+	/*
+	 * Create the action plan node
+	 */
+	actplan = makeNode(MergeAction);
+	actplan->operation = parse->commandType;
+	actplan->matched = parse->matched;
+
+	/* copy the cost from the top_plan */
+	actplan->plan.startup_cost = mainPlan->startup_cost;
+	actplan->plan.total_cost = mainPlan->total_cost;
+	actplan->plan.plan_rows = mainPlan->plan_rows;
+	actplan->plan.plan_width = mainPlan->plan_width;
+
+	/*
+	* Here, the quals expressions are flattened, which is accepted
+	* by deparse functions in EXPLAIN.
+	* But, these expressions will be processed by push_up_vars
+	* latterly and become not flat again. 
+	* So, we need to keep a copy of current quals for explaining.  
+	*/
+	actplan->flattenedqual = (List *) copyObject(parse->jointree->quals);
+	actplan->plan.qual = (List *)parse->jointree->quals;
+
+	/* prepare the target list */
+	if (parse->targetList)
+	{
+		actplan->plan.targetlist = preprocess_targetlist(root,
+										parse->targetList);
+		/*the target list should also be copied for EXPLAIN*/
+		actplan->flattenedtlist = (List *) copyObject(actplan->plan.targetlist);		
+	}
+
+	/*
+	*In general situation, all the vars in target list and quals are flattened.
+	*But, we want them to point to the attributes of the top join plan, not to
+	*the subplans. So push them up again here. 
+	*/
+	push_up_merge_action_vars(actplan, parse);
+
+	if (parse->returningList)
+	{
+		List	   *rlist;
+
+		Assert(parse->resultRelation);
+		rlist = set_returning_clause_references(root->glob,
+								parse->returningList,
+								&actplan->plan,
+								parse->resultRelation);
+		returningLists = list_make1(rlist);
+	}
+	else
+		returningLists = NIL;
+
+	if (parse->rowMarks)
+		rowMarks = NIL;
+	else
+		rowMarks = root->rowMarks;
+
+	result = make_modifytable(parse->commandType,
+							  list_make1_int(parse->resultRelation),
+							  list_make1(actplan),
+							  returningLists,
+							  rowMarks,
+							  NIL,
+							  SS_assign_special_param(root));
+	return result;
+}
+
+/*
  * preprocess_expression
  *		Do subquery_planner's preprocessing work for an expression,
  *		which can be a targetlist, a WHERE clause (including JOIN/ON
@@ -729,6 +883,7 @@ inheritance_planner(PlannerInfo *root)
 	List	   *returningLists = NIL;
 	List	   *rtable = NIL;
 	List	   *rowMarks;
+	List	   *mergeActSets = NIL;
 	List	   *tlist;
 	PlannerInfo subroot;
 	ListCell   *l;
@@ -790,6 +945,66 @@ inheritance_planner(PlannerInfo *root)
 													appinfo->child_relid);
 			returningLists = lappend(returningLists, rlist);
 		}
+
+		/*
+		*For a merge command, we need to generate a set of action plans corresponding
+		*to current result relations. 
+		*The adjust_appendrel_attrs() will not process the merge action list of 
+		*the main query. And, We need to do this here for a MERGE command. 
+		*In fact, no need to do a full query tree mutator on the action queries. 
+		*only adjust the target list and quals.
+		*/
+		if (parse->commandType == CMD_MERGE)
+		{
+			ListCell *e;
+			MergeActionSet *maset;
+
+			/*
+			*the parse in subroot now is a copy of the main query of current result relation
+			*Here we need to generate a copy of the action queries and shift their target table
+			*to current result relation
+			*/
+			subroot.parse->mergeActQry = NIL;
+			
+			foreach(e, parse->mergeActQry)
+			{
+				Query *actqry = (Query *)lfirst(e);
+				Query *newactqry = makeNode(Query);
+
+				/*copy most of the common fields from original query*/
+				*newactqry = *actqry;
+				
+				/*reset the result relation to current child table*/
+				newactqry->resultRelation = subroot.parse->resultRelation;
+
+				/*make the range table to be consistent with current main query*/
+				newactqry->rtable = subroot.parse->rtable;
+
+				/*adjust the target list*/	
+				newactqry->targetList = (List *) adjust_appendrel_attrs(
+															(Node *) actqry->targetList,
+															appinfo);
+				newactqry->targetList = adjust_inherited_tlist(newactqry->targetList, 
+															appinfo);
+				/*and qual*/
+				newactqry->jointree = makeNode(FromExpr);
+				newactqry->jointree->fromlist = subroot.parse->jointree->fromlist;
+				newactqry->jointree->quals = adjust_appendrel_attrs(
+															actqry->jointree->quals,
+															appinfo);
+
+				/*put this new action query in to the action list of current main query*/
+				subroot.parse->mergeActQry = lappend(subroot.parse->mergeActQry, newactqry);				
+			}
+
+			/*
+			* now we have a complete query (main query + action queries) that has been 
+			*shifted to  current result relation. Plan these actions here.
+			*/
+			maset = merge_action_set_planner(&subroot, subplan);
+			Assert(maset != NULL);
+			mergeActSets = lappend(mergeActSets, maset);
+		}
 	}
 
 	root->resultRelations = resultRelations;
@@ -842,6 +1057,7 @@ inheritance_planner(PlannerInfo *root)
 									 subplans,
 									 returningLists,
 									 rowMarks,
+									 mergeActSets,
 									 SS_assign_special_param(root));
 }
 
diff --git a/src/backend/optimizer/prep/preptlist.c b/src/backend/optimizer/prep/preptlist.c
index 59d3518..6faa234 100644
--- a/src/backend/optimizer/prep/preptlist.c
+++ b/src/backend/optimizer/prep/preptlist.c
@@ -78,25 +78,64 @@ preprocess_targetlist(PlannerInfo *root, List *tlist)
 								  result_relation, range_table);
 
 	/*
-	 * for "update" and "delete" queries, add ctid of the result relation into
+	for MERGE command, we also need to expend the target list of the main query.
+	Note that, the target list of main query is the combination of attrs
+	from Source table and target table. We only want to expend the part
+	of target table. 
+
+	We do this in an aggressive way:
+	1. Truncate the old target list, keep only the entries for source table
+	2. expend the target list of result relation from an NIL list. 
+	3. Append this new list at the end of old target list. 
+	*/
+	if (command_type == CMD_MERGE)
+	{
+		ListCell *l;
+		List *TLforResultRelatoin = NIL;
+		int new_resno;
+		
+		Assert(parse->sourceAttrNo > 0);
+		
+		tlist = list_truncate(tlist, parse->sourceAttrNo);
+		
+		TLforResultRelatoin =  expand_targetlist(TLforResultRelatoin, command_type,  
+													result_relation, range_table);
+		new_resno = parse->sourceAttrNo + 1;
+		foreach(l, TLforResultRelatoin)
+		{
+			TargetEntry *te = (TargetEntry *)lfirst(l);
+			te->resno = new_resno++;
+		}
+
+		tlist = list_concat(tlist, TLforResultRelatoin);		
+	}
+
+	/*
+	 * for "update" , "delete"  and "merge" queries, add ctid of the result relation into
 	 * the target list so that the ctid will propagate through execution and
 	 * ExecutePlan() will be able to identify the right tuple to replace or
 	 * delete.	This extra field is marked "junk" so that it is not stored
 	 * back into the tuple.
+	 *
+	 * BUT, if the query node is a merge action,
+	 * we don't need to expand the ctid attribute in tlist.
+	 * The tlist of the merge top level plan already contains
+	 * a "ctid" junk attr of the target relation.
 	 */
-	if (command_type == CMD_UPDATE || command_type == CMD_DELETE)
+	if (!parse->isMergeAction  &&
+			(command_type == CMD_UPDATE ||
+			command_type == CMD_DELETE ||
+			command_type == CMD_MERGE))
 	{
 		TargetEntry *tle;
 		Var		   *var;
 
 		var = makeVar(result_relation, SelfItemPointerAttributeNumber,
 					  TIDOID, -1, 0);
-
 		tle = makeTargetEntry((Expr *) var,
 							  list_length(tlist) + 1,
 							  pstrdup("ctid"),
 							  true);
-
 		/*
 		 * For an UPDATE, expand_targetlist already created a fresh tlist. For
 		 * DELETE, better do a listCopy so that we don't destructively modify
@@ -339,6 +378,7 @@ expand_targetlist(List *tlist, int command_type,
 					}
 					break;
 				case CMD_UPDATE:
+				case CMD_MERGE:
 					if (!att_tup->attisdropped)
 					{
 						new_expr = (Node *) makeVar(result_relation,
diff --git a/src/backend/optimizer/prep/prepunion.c b/src/backend/optimizer/prep/prepunion.c
index 68fe92f..1690a1f 100644
--- a/src/backend/optimizer/prep/prepunion.c
+++ b/src/backend/optimizer/prep/prepunion.c
@@ -101,9 +101,6 @@ static Bitmapset *translate_col_privs(const Bitmapset *parent_privs,
 static Node *adjust_appendrel_attrs_mutator(Node *node,
 							   AppendRelInfo *context);
 static Relids adjust_relid_set(Relids relids, Index oldrelid, Index newrelid);
-static List *adjust_inherited_tlist(List *tlist,
-					   AppendRelInfo *context);
-
 
 /*
  * plan_set_operations
@@ -1740,8 +1737,9 @@ adjust_relid_set(Relids relids, Index oldrelid, Index newrelid)
  * scribble on.
  *
  * Note that this is not needed for INSERT because INSERT isn't inheritable.
+ * But the INSERT actions in MERGE need this function
  */
-static List *
+List *
 adjust_inherited_tlist(List *tlist, AppendRelInfo *context)
 {
 	bool		changed_it = false;
